MODULE Account;
  FROM FIO IMPORT File, OpenRead, Close, Create, RdCard, RdLngCard,
                  WrFixLngReal, WrLn;
  FROM CoreMath IMPORT floor;
  CONST Nmax = 45;
        eps = 1.E-11;
  VAR FHandle : File;
      N, ind : CARDINAL;
      t, Sol : LONGREAL;
      Fib : ARRAY [0..Nmax] OF TEMPREAL;
      S, x1, x2 : TEMPREAL;
BEGIN
  FHandle := OpenRead("Account.IN"); (* ⠥ 室 ,   *)
  N := RdCard(FHandle);              (*    ஢ப *)
  S := TEMPREAL(RdLngCard(FHandle));
  Close(FHandle);                    (*   Handle 㤥 ᯮ짮 *)
                                     (*   뢮 १⮢         *)
  FHandle := Create("Account.OUT");
  IF N = 3    (* ᮡ 砩  ᬮ ⤥쭮 *)
    THEN
      WrFixLngReal(FHandle, LONGREAL(S) - 1., 0, -1);
      WrLn(FHandle);
      WrFixLngReal(FHandle, 1., 0, -1);
      WrFixLngReal(FHandle, LONGREAL(S) - 1., 0, 11);
      Close(FHandle);
      RETURN
  END;

  Fib[0] := 0.;  (* 塞 ⠡ ᥫ  *)
  Fib[1] := 1.;
  FOR ind := 2 TO Nmax DO
    Fib[ind] := Fib[ind-1] + Fib[ind-2]
  END;

  x1 := Fib[N-3] * S;     (*  ᫠ 襭 *)
  x2 := Fib[N-4] * S;
  t := floor(LONGREAL(x1 / Fib[N-1]));
  Sol := ABS(t - floor(LONGREAL(x2 / Fib[N-2])));
  IF ODD(N)
    THEN
      IF x2 - TEMPREAL(floor(LONGREAL(x2 / Fib[N-2]))) * Fib[N-2] < eps
        THEN Sol := Sol - 1.
      END;
      x1 := -x1;
      t := -t
    ELSE
      IF x1 - TEMPREAL(floor(LONGREAL(x1 / Fib[N-1]))) * Fib[N-1] < eps
        THEN Sol := Sol - 1.
      END;
      x2 := -x2
  END;
  t := t - 1.;

  WrFixLngReal(FHandle, Sol, 0, -1);
  WrLn(FHandle);
  IF Sol > eps
    THEN
      WrFixLngReal(FHandle, LONGREAL(x1) - LONGREAL(Fib[N-1]) * t, 0, -1);
      WrFixLngReal(FHandle, LONGREAL(x2) + LONGREAL(Fib[N-2]) * t, 0, 12);
  END;
  Close(FHandle)
END Account.